package org.eclipse.stardust.embedded;

import java.sql.Connection;
import java.sql.SQLException;

import javax.sql.DataSource;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.context.support.GenericApplicationContext;

import org.eclipse.stardust.engine.api.spring.SpringUtils;

/**
 * 
 * @author 
 *
 */
public abstract class AbstractEmbeddedIppContextTest extends AbstractGeneralIppContextTest  {
	private final static Object STATIC_LOCK = new Object();
	private static final String AUDITTRAIL_DATASOURCE = "carnotXaAuditTrailDataSource";

	private static volatile ApplicationContext parentContext;
	
	private static ApplicationContext getParentContext() {
		if (parentContext == null) {
			synchronized (STATIC_LOCK) {
				if (parentContext == null) {
					parentContext = new ClassPathXmlApplicationContext(
							new String[] {
								"carnot-spring-external-context.xml",
								"carnot-spring-external-jms-context.xml",
								"carnot-spring-external-jcr-context.xml"
							});
				}
			}
		}
		return parentContext;
	}
	
	@Override
	protected final String[] getConfigLocations() {
		String[] lBaseConfig = new String[] {
			"carnot-spring-context.xml",
			"carnot-spring-jms-context.xml",
			"carnot-spring-hibernate-context.xml", 
		};
		
		return lBaseConfig;
	}
	
	@Override
	protected final void prepareApplicationContext(GenericApplicationContext pContext) {
		//Attach external systems as parent to the context
		pContext.setParent(getParentContext());
		
		//Avoid to bootstrap again
		SpringUtils.setApplicationContext(pContext);
		
	}
	
	protected Connection getAuditTrailConnection() throws SQLException {
		DataSource lDataSource = (DataSource) getApplicationContext().getBean(AUDITTRAIL_DATASOURCE);
		return lDataSource.getConnection();
	}
}
