package org.eclipse.stardust.embedded.util;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.Arrays;

public final class Util {
	private Util() {}
	
	@Override
	protected Object clone() throws CloneNotSupportedException {
		throw new CloneNotSupportedException();
	}
	
	public static <T> T[] mergeArrays(T[] pBaseArray, T[] pAdditionalArray) {
		T[] retValue = Arrays.copyOf(pBaseArray, pBaseArray.length + pAdditionalArray.length);
		System.arraycopy(pAdditionalArray, 0, retValue, pBaseArray.length, pAdditionalArray.length);
		return retValue;
	}
	
	public static String loadFromFile(File pFile) throws IOException {
		InputStream is = new FileInputStream(pFile);
		InputStream bis = new BufferedInputStream(is);
		try {
			Reader r = new InputStreamReader(bis);
			StringBuilder sb = new StringBuilder((int) Math.min(pFile.length(), Integer.MAX_VALUE));
			int c;
			while ((c = r.read()) != -1) {
				sb.append((char)c);
			}
			return sb.toString();
		} finally {
			bis.close();
		}
	}
}
